// Ultima IV t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{

	char fname[11];
	int i,d;
	int diskid,disknum;

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: u4cut [d88file]\n");
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);

		// fBXN
		if (!disk.ReadDATA(0x01, 0x00, 0x01, 0x10, 0x01, buff, 0x100)) continue;
		diskid = buff[0xff]*0x100 + buff[0xfe];
		disknum = 0;

		switch (diskid)
		{
		case 0x0123:
			printf("Ultima Disk F܂.\n");
			fcut("PROG",    0x03, 0x01, 0x01, 0x01, 0x01, 0x0000, 0x4000);

			for (i=0; i<5; i++)
			{
				sprintf(fname,"MUS%02d",i);
				fcut(fname, 0x44+(i+1)/2, (0x44+(i+1)/2)/2, (0x44+(i+1)/2)&1, 1+(8*(i+1))%16, 0x01, 0x0000, 0x800);
			}
			break;

#if 0
		case 0x3456:
			printf("New World Disk F܂.\n");
			break;

		case 0x6789:
			printf("Britania Disk F܂.\n");
			break;

		case 0x9abc:
			printf("Town Disk F܂.\n");
			break;

		case 0xcdef:
			printf("Underground Disk F܂.\n");
			break;
#endif

		default:
			continue;
		}

		// ȃf[^؂o
	}
	return 0;
}

